import java.awt.Robot;
import java.awt.AWTException;
import java.awt.event.KeyEvent;

//  refer to this code: https://gist.github.com/timpulver/3775852
public class KeystrokeSimulator {
  int threUp, threDown, threLeft, threRight; 

  private Robot robot;
  
  KeystrokeSimulator(){
    try{
      robot = new Robot();  
    }
    catch(AWTException e){
      println(e);
    }
    threUp = -70;
    threDown = 70;
    threLeft = -70;
    threRight = 70;
  }
  
  void simChar(char c)  {
    robot.keyPress(c);
  }
  void simKeyEvent(int i)  {
    robot.keyPress(i);
  }
  
  void simulate(char c) throws AWTException {
    robot.keyPress(c);
  }
  
  void setDirKeyThreshold(int threshold_up, int threshold_down, int threshold_left, int threshold_right) {
    threUp     = threshold_up;
    threDown   = threshold_down;
    threLeft   = threshold_left;
    threRight  = threshold_right;
  }
  
  void simulKeyDirInput(PVector vect_dir) {
    //  key simulation
    if ( threRight < vect_dir.x ) {
      simKeyEvent(KeyEvent.VK_RIGHT);
    } else if ( vect_dir.x < threLeft ) {
      simKeyEvent(KeyEvent.VK_LEFT);
    }
  
    if ( threDown < vect_dir.y ) {
      simKeyEvent(KeyEvent.VK_DOWN);
    } else if ( vect_dir.y < threUp ) {
      simKeyEvent(KeyEvent.VK_UP);
    }
  }
  
  
}
